=== debian/control ===
Source: ros-humble-schunk-svh-library
Section: misc
Priority: optional
Maintainer: Stefan Scherzinger <scherzin@fzi.de>
Build-Depends: debhelper (>= 9.0.0), cmake, libboost-all-dev, libboost-all-dev <!nocheck>, ros-humble-ros-workspace
Homepage: http://wiki.ros.org/schunk_svh_library
Standards-Version: 3.9.2

Package: ros-humble-schunk-svh-library
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-humble-ament-cmake, ros-humble-ros-workspace
Description: Standalone C++ library for accessing the Schunk five finger hand.
